# Release checklist

## In the master branch before releasing

* [ ] Create a MR for the master branch for the following changes:
* update/review `docs/*` and make sure it matches the current state
  * [ ] Update how to checkout the latest stable tag
  * [ ] Document how to upgrade in `docs/upgrade.md`
* [ ] Update dependencies in `requirements.txt` by following the
      instructions in `requirements.in`
* [ ] update [CHANGELOG.md](https://keepachangelog.com/en/1.0.0/)
  * [ ] Include `Known issues`
* [ ] Update the version number in the `VERSION` file
* [ ] Commit (signed)
* [ ] Push to MR
* [ ] Make sure master pipeline is successful before merging MR !
* [ ] Wait for MR to get merged into master

## Push a signed tag

* [ ] Make sure the master pipeline succeeds for the last commit before tagging. This
      is important because tags should not get retagged !
* [ ] Create and push signed tag (`git tag -s 0.6.0 -m 'Release 0.6.0'; git push --tags`)

## In the new release branch

* [ ] If this is a major release, create a new release branch (i.e. `v0.6`)

Create a MR for the new branch with the following changes:

* Ensure all dependencies are updated and locked (locking should be done
    only on the release branch):
  * [ ] flux chart versions: `find flux2/* -type f -exec yq eval .spec.chart {} \;`
* [ ] Wait for MR to get merged

## After release

* [ ] Log into https://readthedocs.org and update documentation for tagged versions
* [ ] Cherry-pick all changes from the release branch into master which
      shouldn't be only in the 0.4.0 branch (i.e. not the commit locking the
      dependencies)
* [ ] Create issue for creating a release blog post
* [ ] Celebrate :clinking_glass: !!
